/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <joerg@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.        Joerg Wunsch
 * ----------------------------------------------------------------------------
 *
 * Simple AVR demonstration.  Controls a LED that can be directly
 * connected from OC1/OC1A to GND.  The brightness of the LED is
 * controlled with the PWM.  After each period of the PWM, the PWM
 * value is either incremented or decremented, that's all.
 *
 * $Id: demo.c,v 1.4 2004/07/21 21:03:07 joerg_wunsch Exp $
 */

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <stdlib.h>

#if defined(__AVR_AT90S2313__)
#  define OC1 PB3
#  define OCR OCR1
#  define DDROC DDRB
#elif defined(__AVR_AT90S2333__) || defined(__AVR_AT90S4433__)
#  define OC1 PB1
#  define DDROC DDRB
#  define OCR OCR1
#elif defined(__AVR_AT90S4414__) || defined(__AVR_AT90S8515__) || \
      defined(__AVR_AT90S4434__) || defined(__AVR_AT90S8535__) || \
      defined(__AVR_ATmega163__)
#  define OC1 PD5
#  define DDROC DDRD
#  define OCR OCR1A
#elif defined(__AVR_ATmega8__)
#  define OC1 PB1
#  define DDROC DDRB
#  define OCR OCR1A
#  define PWM10 WGM10
#  define PWM11 WGM11
#elif defined(__AVR_ATmega32__)
#  define OC1 PD5
#  define DDROC DDRD
#  define OCR OCR1A
#  define PWM10 WGM10
#  define PWM11 WGM11
#elif defined(__AVR_ATmega64__) || defined(__AVR_ATmega128__)
#  define OC1 PB5
#  define DDROC DDRB
#  define OCR OCR1A
#  define PWM10 WGM10
#  define PWM11 WGM11
#else
#  error "Don't know what kind of MCU you are compiling for"
#endif

#if defined(COM11)
#  define XCOM11 COM11
#elif defined(COM1A1)
#  define XCOM11 COM1A1
#else
#  error "need either COM1A1 or COM11"
#endif

//#define E unsigned __attribute__ ((sectionn(".eeprom")))
#define RS PC0
#define EN PC2
//#define SB PB2
#define TIME 2
/*
static E char t0[]="=E?aa?-a?aaaa?ee"?
static E char t1[]="caaoeiaeoa ?enei iiiii?eoe ia";
static E char t2[]="aiaaeoa ?ica?e?ou ia";
static E char t3[]="A?ai?i?ou caaoiaia ?enei";
static E char t4[]="A ian iieo?eeinu";
*/
void pause(unsigned int a)
{
unsigned int cn;
for (cn=a; cn>0; cn-- );
}
void lcd_com(unsigned char p)
{
PORTC &=~_BV(RS);
PORTC |= _BV(EN);
PORTD = p;
pause (TIME);
PORTC &=~_BV(EN);
pause (5*TIME);
}

void lcd_dat(unsigned char p)
{
PORTC |= _BV(RS) | _BV(EN);
PORTD = p;
 pause(TIME);
 PORTC &=~_BV(EN);
 pause(5*TIME);
 }
 
 void lcd_init(void)
 {
 lcd_com(0x08);
 lcd_com(0x38); pause(1000*TIME);
 lcd_com(0x38); pause(20*TIME); 
 lcd_com(0x38); lcd_com(0x38); 
 lcd_com(0x01); pause(100*TIME); 
 lcd_com(0x06);
 lcd_com(0x0D);
 }

int
main (void)
{
//unsigned char a, b, c;
//unsigned int d=0, e=0;
unsigned char cifra = 0, b;
PORTB = DDRD = 0xFF;
PORTC = 0xF8; DDRC = 0x07;
lcd_init();
/*
lcd_dat('H');
lcd_dat('e');
lcd_dat('l');
lcd_dat('o');
*/
while (1)
{
	lcd_com(0x0C);
	lcd_com(0x86);
	lcd_dat(cifra/100+0x30);
	lcd_dat((cifra/10)%10 + 0x30);
	lcd_dat(cifra%10 + 0x30);
	lcd_dat('=');
	lcd_dat(cifra);
	for(b=0; b<10; b++) pause (25000);
	lcd_com(0x86);
	for(b=0; b<5; b++) lcd_dat(' ');
	cifra++	;
}
}
